#################################################################
#            This is a demo mockup for IFU Recon Mapping tool
# (Hence the code is very rough as I am simply playing with ideas)
# MNB
# Note: I'm having to leave this as the OptEx has become no 1 priority
# (Mon Jan 8th 2007). I hope that we can get back to this.
#################################################################


# ========
# THOUGHTS
# ========
# Scale Options:
# Absolute min and max
# Percintile
# Median+-n*Sigma

#################################################################

# -------------------------------------------------------------
# -------------------------------------------------------------

# Define Global variables that define the attributes
global IfuMap
set IfuMap(nrows) 32
set IfuMap(ncols) 16
set IfuMap(tile_width) 25;#40
set IfuMap(tile_height) 25;#18

set IfuMap(colour,grid) slategrey
set IfuMap(colour,text) cyan
set IfuMap(colour,highlight) yellow; # black ;#slategrey

set IfuMap(root) .ifuMap

set IfuMap(pnames,1) "P1"
set IfuMap(pnames,2) "P2"
set IfuMap(pnames,3) "P3"
set IfuMap(pnames,4) "P4"

# -------------------------------------------------------------
# -------------------------------------------------------------

proc IfuMap:CreateWindow {} {

    global IfuMap
    
    set nrows $IfuMap(nrows)
    set ncols $IfuMap(ncols)
    set tile_width $IfuMap(tile_width)
    set tile_height $IfuMap(tile_height)

    set width  [expr $tile_width*$ncols]
    set height [expr $tile_height*$nrows] 
    set root $IfuMap(root)
    destroy $root
    toplevel $root
    set c $root.canvas
    canvas $c -width $width -height $height -bg grey
    set bframe $root.bframe
    frame $bframe -relief raised -bd 1
    set dframe $root.dframe
    frame $dframe -relief sunken -bd 2 -bg white
    grid $c -row 0 -column 0
    grid $bframe -row 0 -column 1 -sticky ns
    grid $dframe -row 1 -column 0 -sticky we
	
    set ylast [expr ($nrows+1)*$tile_height]
    for {set i 1} {$i<=$nrows} {incr i 1} {
	set y0 [expr ($nrows-$i)*$tile_height]
	set y1 [expr $y0+$tile_height]
	if {$i!=1} {
	    set x0 0
	    set x1 [expr $ncols*$tile_width]
	    $c create line $x0 $y1 $x1 $y1\
		-fill $IfuMap(colour,grid) -stipple gray50\
		-tags grid
	}

	for {set j 1} {$j<=$ncols} {incr j 1} {
	    set x0 [expr ($j-1)*$tile_width]
	    set x1 [expr $j*$tile_width]			
	    if {$j!=$ncols} {
		$c create line $x1 0 $x1 $ylast\
		    -fill $IfuMap(colour,grid) -stipple gray50\
		    -tags grid
	    }
		
	    set tile      ${i}:${j} 
	    set tile_text ${i}:${j}:type 
	    $c create rectangle $x0 $y0 $x1 $y1\
		-tags "$tile rectangle"
	    set xm [expr 0.5*($x0+$x1)]
	    set ym [expr 0.5*($y0+$y1)]
	    $c create text $xm $ym -anchor c -text ""\
		-fill $IfuMap(colour,text)\
		-tags "$tile_text text"
	    IfuMap:SetupTileBinds $c $tile $tile_text
	    IfuMap:SetTileType $tile ""
	}
    }
	
    bind $c <B1-Motion>  "IfuMap:CanvasBindB1Motion $c %x %y"
    bind $c <ButtonRelease-1> "IfuMap:CanvasBindB1Release $c %x %y"
    $c bind grid <ButtonPress-1> {IfuMap:SetSelection ""}
    
    # FILE
    label $bframe.l1 -text "File"
    button $bframe.save   -text "Save" \
	-command "IfuMap:SaveFibInfo" -state disabled
    button $bframe.quit   -text "Quit" -command "destroy $root"
    pack  $bframe.l1 $bframe.save $bframe.quit  -side top -fill x
	
    # DISPLAY
    frame $bframe.j1 -height 30
    label $bframe.l0 -text "Display"
    checkbutton $bframe.grid  -text Grid -relief raised\
	-variable IfuMap(disvar,grid) \
	-command "IfuMap:ToggleGrid $c grid"
    set  IfuMap(disvar,grid) 1
    checkbutton $bframe.text -text Text -relief raised\
	-variable IfuMap(disvar,text) \
	-command "IfuMap:ToggleText $c text"
    set  IfuMap(disvar,text) 1
    button $bframe.grayscale -text Grayscale... \
	-command IfuMap:GrayScalePanel
    pack $bframe.j1 $bframe.l0 $bframe.grid  $bframe.text $bframe.grayscale\
	-side top -fill x

    # PLOT
    frame $bframe.j2 -height 30
    label $bframe.lp -text "Plot"
    button $bframe.plot1  -text "Plot P1" \
	-command "IfuMap:PlotProg P1" -state disabled
    button $bframe.plot2  -text "Plot P2" \
	-command "IfuMap:PlotProg P2" -state disabled
    button $bframe.plot3  -text "Plot P3" \
	-command "IfuMap:PlotProg P3" -state disabled
    button $bframe.plot4  -text "Plot P4" \
	-command "IfuMap:PlotProg P4" -state disabled
    button $bframe.plotxycut  -text "Plot XY Cut" \
	-command "IfuMap:PlotXYCut" -state disabled
    pack $bframe.j2 $bframe.lp\
	$bframe.plot1 $bframe.plot2 $bframe.plot3 $bframe.plot4\
	$bframe.plotxycut -side top -fill x
	
    # EDIT
    label $bframe.l -text "Edit"
    button $bframe.pnames -text "Names..." -command IfuMap:SetNamesPanel
    button $bframe.prog1 -text "Prog1" \
	-command "IfuMap:SetSelectionToType P1" -state disabled
    button $bframe.prog2 -text "Prog2" \
	-command "IfuMap:SetSelectionToType P2" -state disabled
    button $bframe.prog3 -text "Prog3" \
	-command "IfuMap:SetSelectionToType P3" -state disabled
    button $bframe.prog4 -text "Prog4" \
	-command "IfuMap:SetSelectionToType P4" -state disabled
    button $bframe.u     -text "Und" \
	-command "IfuMap:SetSelectionToType \"\"" -state disabled
    button $bframe.sky   -text "Sky " \
	-command "IfuMap:SetSelectionToType S" -state disabled
    button $bframe.dead  -text "Dead" \
	-command "IfuMap:SetSelectionToType D" -state disabled
    pack $bframe.dead $bframe.u $bframe.sky\
	$bframe.prog4 $bframe.prog3 $bframe.prog2 $bframe.prog1 \
	$bframe.pnames $bframe.l -fill x -side bottom
    set IfuMap(path,undef_button) $bframe.u 
    set IfuMap(path,sky_button) $bframe.sky
    set IfuMap(path,prog_button1) $bframe.prog1
    set IfuMap(path,prog_button2) $bframe.prog2
    set IfuMap(path,prog_button3) $bframe.prog3
    set IfuMap(path,prog_button4) $bframe.prog4
    set IfuMap(path,dead_button) $bframe.dead 
    set IfuMap(edit_buttons) "undef_button sky_button prog_button1\
			prog_button2 prog_button3 prog_button4 dead_button"
    set IfuMap(path,plot,P1) $bframe.plot1
    set IfuMap(path,plot,P2) $bframe.plot2
    set IfuMap(path,plot,P3) $bframe.plot3
    set IfuMap(path,plot,P4) $bframe.plot4
    set IfuMap(path,plotxycut_button) $bframe.plotxycut
    set IfuMap(plot_buttons) "plot1 plot2 plot3 plot4"
    set IfuMap(path,save_button) $bframe.save 
	
    label $dframe.l -textvariable IfuMap(disvar,display) -bg white
    pack $dframe.l -side left -fill x
			
    set IfuMap(canvas) $c
}

proc IfuMap:ToggleGrid {canvas grid_tag} {
    global IfuMap
    if {$IfuMap(disvar,grid)} {
	set colour $IfuMap(colour,grid)
    } else {
	set colour ""
    }
    $canvas itemconfig $grid_tag -fill $colour
}

proc IfuMap:ToggleText {canvas text_tag} {
    global IfuMap
    if {$IfuMap(disvar,text)} {
	set colour $IfuMap(colour,text)
    } else {
	set colour ""
    }
    $canvas itemconfig $text_tag -fill $colour
}

proc IfuMap:PlotProg {match_type} {	

    global IfuMap
    
    set rowlist ""
    set tilelist ""
    for {set i 1} {$i<=$IfuMap(nrows)} {incr i 1} {
	for {set j 1} {$j<=$IfuMap(ncols)} {incr j 1} {
	    set tile ${i}:${j}
	    set type [IfuMap:GetTileType $tile]
	    if {$type==$match_type} {
		puts "tile=$tile"
		set fibno [IfuMap:Tile2FibreNo $tile]
		lappend rowlist $fibno
		lappend tilelist $tile
	    }
	}
    }
    puts $tilelist	
    puts $rowlist
	
    set fitsfile [IfuMap:GetReduceFile]
    IfuMap:ViewSumRows $fitsfile $rowlist
}

proc IfuMap:UpdatePlotStates {} {

    global IfuMap

    set type_list "P1 P2 P3 P4"
    set rowlist ""
    set tilelist ""
    foreach type $type_list {set non_empty($type) 0}
    for {set i 1} {$i<=$IfuMap(nrows)} {incr i 1} {
	for {set j 1} {$j<=$IfuMap(ncols)} {incr j 1} {
	    set tile ${i}:${j}
	    set type [IfuMap:GetTileType $tile]
	    foreach match_type $type_list {
		if {$type==$match_type} {
		    set non_empty($type) 1
		}
	    }
	}
    }
	
    foreach type $type_list {
	if {$non_empty($type)} {
	    $IfuMap(path,plot,$type) configure -state normal
	} else {
	    $IfuMap(path,plot,$type) configure -state disabled
	}
    }
}

proc IfuMap:SetNamesPanel {} {

    global IfuMap
    global IfuMapNamesPanel
    
    set root $IfuMap(root).ifuMapSetNamesPanel
    destroy $root
    toplevel $root
    wm transient $root $IfuMap(root)
    wm title $root "Prog Names:"
    set IfuMapNamesPanel(root) $root
	
    frame $root.top -relief raised -bd 2
    frame $root.bot -relief raised -bd 2
    pack $root.top $root.bot -fill both -expand 0 -ipadx 2m -ipady 2m
	
    set n 4
    set lroot $root.top
    for {set i 1} {$i<=$n} {incr i 1} {
	set label $lroot.l${i}
	set entry $lroot.e${i}
	label $label -text "P${i}:"
	entry $entry -width 16 -textvariable IfuMapNamesPanel(disvar,$i)
	grid $label -column 1 -row $i
	grid $entry -column 2 -row $i
	
	set IfuMapNamesPanel(disvar,$i) $IfuMap(pnames,$i)
    }
	
    set lroot $root.bot
    button $lroot.ok -text Ok -width 7 -command IfuMap:SetNamesPanelOk
    button $lroot.cancel	 -text Cancel -width 7 -command "destroy $root"
    pack $lroot.ok $lroot.cancel -side left -pady 2 -fill x -expand 1
}

proc IfuMap:SetNamesPanelOk {} {

    global IfuMap
    global IfuMapNamesPanel

    set n 4 
	
    set change_flag 0
    for {set i 1} {$i<=$n} {incr i 1} {		
	if {$IfuMap(pnames,$i)==$IfuMapNamesPanel(disvar,$i)} {
	    continue
	}
	set change_flag 1
	set IfuMap(pnames,$i) $IfuMapNamesPanel(disvar,$i)
    }
    destroy $IfuMapNamesPanel(root)
    
    if {$change_flag} {
	IfuMap:EnableSaveButton
	#IfuMap:UpdateTileNames
    }
}

proc IfuMap:GrayScalePanel {} {

    global IfuMap
    global IfuMapPanel
    global IfuMap:sdataA
    
    set mainroot $IfuMap(root)
    set root $mainroot.grayscalePanel
    set IfuMapPanel(root) $root
    destroy $root
    toplevel $root
    wm transient $root $mainroot
    wm title $root "Gray Scale Settings:"
	
    set statframe $root.statframe
    set clipframe $root.clipframe
    set buttonframe $root.buttonframe
    frame $statframe -relief raised -bd 2
    frame $clipframe -relief raised -bd 2
    frame $buttonframe -relief raised -bd 2
    pack $statframe $clipframe $buttonframe -fill x \
	-expand 1 -ipadx 2m -ipady 2m
	
    # Statistic info display frame
    label $statframe.l -text "Statistics:"
    text  $statframe.text -bg white -yscrollcommand "$statframe.sb set"
    scrollbar $statframe.sb -command  "$statframe.text yview"
    grid  $statframe.l -row 0 -column 0 -sticky w
    grid $statframe.text -row 1 -column 0
    grid $statframe.sb -row 1 -column 1 -sticky ns
    set text $statframe.text
	
    # Clip Value Entry frame
    label $clipframe.lmin -text "Clipped Min:"
    entry $clipframe.emin -textvariable IfuMapPanel(disvar,clipmin)
    label $clipframe.lmax -text "Clipped Max:"
    entry $clipframe.emax -textvariable IfuMapPanel(disvar,clipmax)
    button $clipframe.stat -text "Stat Clipped..." \
	-command IfuMap:GrayScalePanelStatClippedData
    pack $clipframe.lmin $clipframe.emin $clipframe.lmax $clipframe.emax\
	-side left
    pack $clipframe.stat -side left -padx 4m 
	
    # Action Buttons frame
    button $buttonframe.apply -text Apply -width 7 \
	-command IfuMap:GrayScalePanelApply
    button $buttonframe.close -text Close -width 7 -command "destroy $root"
    pack  $buttonframe.apply $buttonframe.close -side left -fill x -padx 4m

    set IfuMapPanel(disvar,clipmin) [set IfuMap:sdataA(used_min)]
    set IfuMapPanel(disvar,clipmax) [set IfuMap:sdataA(used_max)]

    $text insert end "Full data range statistics:\n"
    IfuMap:GrayScalePanelDisplayStats $text

    set IfuMapPanel(path,text) $text
}

proc IfuMap:GrayScalePanelApply {} {

    global IfuMap
    global IfuMapPanel
    global IfuMap:dataA
    global IfuMap:sdataA
	
    set clipmin $IfuMapPanel(disvar,clipmin)
    if {![string is double $clipmin]} {
	set IfuMapPanel(disvar,clipmin) ""
	return
    }
	
    set clipmax $IfuMapPanel(disvar,clipmax)
    if {![string is double $clipmax]} {
	set IfuMapPanel(disvar,clipmax) ""
	return
    }
	
    if {$clipmax<$clipmin} {
	set IfuMapPanel(disvar,clipmin) ""
	set IfuMapPanel(disvar,clipmax) ""
	return
    }

    IfuMap:GenScaleData IfuMap:dataA IfuMap:sdataA $clipmin $clipmax
    IfuMap:ColourTiles IfuMap:sdataA
} 

proc IfuMap:GrayScalePanelStatClippedData {} {

    global IfuMapPanel
		
    set clipmin $IfuMapPanel(disvar,clipmin)
    set clipmax $IfuMapPanel(disvar,clipmax)
    set textpath $IfuMapPanel(path,text)
	
    $textpath insert end \n
    $textpath insert end \
	"Clipped data statistics From: $clipmin To: $clipmax\n"
    IfuMap:GrayScalePanelDisplayStats $textpath 1 $clipmin $clipmax
    $textpath yview end
}

proc IfuMap:GrayScalePanelDisplayStats {textpath {clip_flag 0} \
					    {clipmin ""} {clipmax ""}} {

    global IfuMap:dataA
	
    set lst  [set IfuMap:dataA(list)]
    if {$clip_flag} {
	set lst1 [set IfuMap:dataA(sorted_list)]
	set idx1 [vexpr SUM(lst1<$clipmin)]
	set idx2 [vexpr SUM(lst1<=$clipmax)]
	set lst2 [lrange $lst1 $idx1 $idx2]
    } else {
	set lst2 [set IfuMap:dataA(sorted_list)]
    }
		
    set min [lindex $lst2 0]
    set max [lindex $lst2 end]
    set n   [llength $lst2]
    set data_pc [expr 100*$n/[llength $lst]]
	
    $textpath insert end "n=$n (${data_pc}%) \n"
    $textpath insert end "Range: \[ $min , $max \]\n"
    
    set avr [vexpr AVERAGE(lst2)]
    set std [vexpr STDDEV(lst2)]
    set med [vexpr MEDIAN(lst2)]
    $textpath insert end "AVR=$avr STD=$std MED=$med\n"
    
    $textpath insert end \n
    
    set lst3 $lst2
    set n [llength $lst3]
    set pc_list {1 10 95 , 2 30 96 , 3 50 97 , 4 70 98 , 5 90 99} 
    foreach pc $pc_list {
	if {$pc==","} {
	    $textpath insert end \n
	    continue
	}

	set idx [expr int(0.01*$pc*$n)]
	set val [lindex $lst3 $idx]
	set val [format "%f" $val]
	$textpath insert end "$pc%=$val\t"
    }
    $textpath insert end \n\n
	
    return
	
    set pidx [vexpr SUM(lst2<=0.0)]
    set lst3 [lrange $lst2 $pidx end]
    puts "[lindex $lst3 0] - [lindex $lst3 end]"
    puts "n  =[llength $lst3]"
    puts "AVR=[vexpr AVERAGE(lst3)]"
    puts "STD=[vexpr STDDEV(lst3)]"
    puts "MED=[vexpr MEDIAN(lst3)]"
	
    set pc_list {0 10 20 30 40 50 60 70 80 90 95 96 97 98 99}
    set n [llength $lst3]
    set file tmp_dist.dat
    if {[file exists $file]} {
	file delete $file
    }
    set fid [open $file w]
    foreach pc $pc_list {
	set idx [expr int(0.01*$pc*$n)]
	set val [lindex $lst3 $idx]
	puts "$pc%=$val"
	puts $fid "$val $pc"
    }
    close $fid
	
    set med [vexpr MEDIAN(lst3)]
    set l3  [vexpr abs(lst3-$med)]
    set meddev [vexpr MEDIAN(l3)]
    puts "$med $meddev"
    
    set n [llength $lst3]
    set idx [expr int($n/2)]
    set lst4 [lrange $lst3 0 $idx]
    puts "n  =[llength $lst4]"
    puts "AVR=[vexpr AVERAGE(lst4)]"
    puts "STD=[vexpr STDDEV(lst4)]"
    puts "MED=[vexpr MEDIAN(lst4)]"
    
    set lst4 [lrange $lst3 $idx end]
    puts "n  =[llength $lst4]"
    puts "AVR=[vexpr AVERAGE(lst4)]"
    puts "STD=[vexpr STDDEV(lst4)]"
    puts "MED=[vexpr MEDIAN(lst4)]"
	
#	set l3 [vexpr abs(lst2)]
#	set meddev [vexpr MEDIAN(l3)]
#	puts "meddev=$meddev"
	
    set idx [expr int ([llength $lst2]*0.95)]
    set max [lindex $lst2 $idx]
    #set min [lindex $lst2 0]
    #set max [lindex $lst2 end]
    set idx [expr int ([llength $lst2]*0.98)]
    set use_max [lindex $lst2 $idx]
    set idx [expr int ([llength $lst2]*0.02)]
    set use_min [lindex $lst2 $idx]
    set use_max 26
}

# ---------------------------------------------
proc IfuMap:SetupTileBinds {canvas tile tile_text} {

    $canvas bind $tile <ButtonPress-1> "IfuMap:TileBindB1 $canvas $tile"
    $canvas bind $tile_text <ButtonPress-1> "IfuMap:TileBindB1 $canvas $tile"
    $canvas bind $tile <Double-ButtonPress-1> \
	"IfuMap:TileBindDoubleB1 $canvas $tile"
    $canvas bind $tile_text <Double-ButtonPress-1> \
	"IfuMap:TileBindDoubleB1 $canvas $tile"
    $canvas bind $tile <Control-ButtonPress-1> \
	"IfuMap:TileBindShiftB1 $canvas $tile"
    $canvas bind $tile_text <Control-ButtonPress-1> \
	"IfuMap:TileBindShiftB1 $canvas $tile"
    $canvas bind $tile <Any-Enter> "IfuMap:TileBindEnter $canvas $tile"
    $canvas bind $tile_text <Any-Enter> "IfuMap:TileBindEnter $canvas $tile"
    $canvas bind $tile <Any-Leave> "IfuMap:TileBindLeave $canvas $tile"
#	$canvas bind $tile <B1-Motion> "puts \"B1 Enter $tile\""
#	$canvas bind $tile <ButtonPress-1> "puts $tile"
}

proc IfuMap:TileBindDoubleB1 {canvas tile} {

    set fibreno  [IfuMap:Tile2FibreNo $tile]
    set redfile [IfuMap:GetReduceFile]
    puts "FitsOps:ViewRow $redfile $fibreno"
    #set result [FitsOps:ViewRow $redfile $fibreno]
    set result [IfuMap:ViewSumRows $redfile "$fibreno"]
    if {$result!=""} {
	set msg "Unable to plot for fibre $fibreno"
	#tk_message -message $msg -type ok
	puts $msg
    }
}

proc IfuMap:CanvasBindB1Motion_old {canvas x y} {

    global IfuMap

    set lst [$canvas find overlapping $x $y $x $y]
    set tile ""
    foreach itm $lst {
	set tags [$canvas gettags $itm]
	if {[lsearch $tags rectangle]!=-1} {
	    set tile [lindex $tags 0]
	    break
	}
    }
    if {$tile==""} {
	return
    }
    set type  [IfuMap:GetTileType $tile]
    set value [IfuMap:GetTileType $tile]
    set fibno [IfuMap:Tile2FibreNo $tile]
    set IfuMap(disvar,display) \
	"Tile=$tile\t Type=$type\tValue=$value Fibre=$fibno" 
    #$canvas itemconfig $tile -outline slategrey
    IfuMap:AppendSelection $tile
    #IfuMap:Highlight $tile	
}

set IfuMap(last_tile) ""

proc IfuMap:CanvasBindB1Motion {canvas x y} {
    global IfuMap
    set ix [expr int($x/$IfuMap(tile_width))+1]
    set iy [expr $IfuMap(nrows)-int($y/$IfuMap(tile_height))]
    set tile ${iy}:${ix}
    if {$IfuMap(last_tile)==$tile} {
	return
    }
    set tile_chain [IfuMap:GetTileChain $IfuMap(last_tile) $tile]
    foreach chain $tile_chain {IfuMap:AppendSelection $chain}
    set IfuMap(last_tile) $tile
}

proc IfuMap:CanvasBindB1Release {canvas x y} {
    global IfuMap
    set IfuMap(last_tile) ""
}

proc IfuMap:TileBindB1 {canvas tile} {
    #$canvas itemconfig $tile -outline slategrey
    IfuMap:SetSelection $tile
    #IfuMap:Highlight $tile
}

proc IfuMap:TileBindShiftB1 {canvas tile} {
    #$canvas itemconfig $tile -outline slategrey
    set selset [IfuMap:GetSelection]
    set idx [lsearch $selset $tile]
    if {$idx==-1} {
	IfuMap:AppendSelection $tile
    } else {
	IfuMap:SetSelection [lreplace $selset $idx $idx]
    }
    #IfuMap:Highlight $tile
}

proc IfuMap:TileBindEnter {canvas tile} {
    global IfuMap
    set rowcol [split $tile :]
    set xgpos [lindex $rowcol 1]
    set ygpos [lindex $rowcol 0]
    set type  [IfuMap:GetTileType $tile]
    if {$type==""} {
	set type "U"
    }
    set value [IfuMap:GetTileValue $tile]
    set fibno [IfuMap:Tile2FibreNo $tile]
    #	set dstr [format \
	"Tile=%5s XGPOS=%2s YGPOS=%2s Type=$type Value=%4.2f Fibre=$fibno"\
#		 $tile $xgpos $ygpos $value]
    set dstr [format "XGPOS=%2s YGPOS=%2s Type=$type Value=%4.2f Fibre=$fibno"\
		  $xgpos $ygpos $value]
    set IfuMap(disvar,display) $dstr
}

proc IfuMap:TileBindLeave {canvas tile} {
    global IfuMap
    set IfuMap(disvar,display) ""
}

proc IfuMap:GetTileChain {tile1 tile2} {
	
    if {$tile1==$tile2||$tile1==""} {
	return [list $tile2]
    }
	
    set rowcol1 [split $tile1 :]
    set rowcol2 [split $tile2 :]
    set row1 [lindex $rowcol1 0]
    set col1 [lindex $rowcol1 1]
    set row2 [lindex $rowcol2 0]
    set col2 [lindex $rowcol2 1]
	
    set chain ""
    
    if {$col1==$col2} {
	if {$row2<$row1} {
	    set tmp $row1
	    set row1 $row2
	    set row2 $tmp
	}
	for {set row $row1} {$row<=$row2} {incr row 1} {
	    set tile ${row}:${col1}
	    lappend chain $tile
	}
		
	return $chain
    }
	
    if {$row1==$row2} {
	if {$col2<$col1} {
	    set tmp $col1
	    set col1 $col2
	    set col2 $tmp
	}
	if {$col2>$col1} {
	    set step 1
	} {
	    set step -1
	}
	for {set col $col1} {$col<=$col2} {incr col $step} {
	    set tile ${row1}:${col}
	    lappend chain $tile
	}
		
	return $chain
    }
	
    return [list $tile1 $tile2]
}

# ---------------------------------------------
set IfuMapSelection ""

proc IfuMap:SetSelection {tile_list} {

    global IfuMapSelection

    foreach tile $IfuMapSelection {IfuMap:DeHighlight $tile}
    set IfuMapSelection $tile_list
    foreach tile $IfuMapSelection {IfuMap:Highlight $tile}
    if {[llength $IfuMapSelection]==0} {
	IfuMap:DisableEditButtons
    } else {
	IfuMap:EnableEditButtons
    }
    if {[llength $IfuMapSelection]==1} {
	IfuMap:EnablePlotXYCutButton
    } else {
	IfuMap:DisablePlotXYCutButton
    }
}

proc IfuMap:AppendSelection {tile} {

    global IfuMapSelection
	
    if {[lsearch $IfuMapSelection $tile]==-1} {
	lappend IfuMapSelection $tile
	IfuMap:Highlight $tile
    }
    if {[llength $IfuMapSelection]==0} {
	IfuMap:DisableEditButtons
    } else {
	IfuMap:EnableEditButtons
    }
    if {[llength $IfuMapSelection]==1} {
	IfuMap:EnablePlotXYCutButton
    } else {
	IfuMap:DisablePlotXYCutButton
    }
}

proc IfuMap:GetSelection {} {
    global IfuMapSelection
    return $IfuMapSelection
}

proc IfuMap:DisableEditButtons {} {
    global IfuMap
    foreach button $IfuMap(edit_buttons) {
	$IfuMap(path,$button)  configure -state disabled
    }
}

proc IfuMap:EnableEditButtons {} {
    global IfuMap
    foreach button $IfuMap(edit_buttons) {
	$IfuMap(path,$button)  configure -state normal
    }
}
proc IfuMap:EnablePlotXYCutButton {} {
    global IfuMap
    $IfuMap(path,plotxycut_button) configure -state normal
}

proc IfuMap:DisablePlotXYCutButton {} {
    global IfuMap
    $IfuMap(path,plotxycut_button) configure -state disabled
}

proc IfuMap:EnableSaveButton {} {
    global IfuMap
    $IfuMap(path,save_button) configure -state normal
}

proc IfuMap:DisableSaveButton {} {
    global IfuMap
    $IfuMap(path,save_button) configure -state disabled
}

# ---------------------------------------------
proc IfuMap:Highlight {tile} {
    global IfuMap
    set canvas $IfuMap(canvas)
    $canvas itemconfig $tile -outline $IfuMap(colour,highlight)
    $canvas raise $tile
    $canvas raise text
}

proc IfuMap:DeHighlight {tile} {
    global IfuMap
    set canvas $IfuMap(canvas)
    $canvas itemconfig $tile -outline ""
    $canvas raise grid
}

# ---------------------------------------------
proc IfuMap:SetSelectionToType {type} {

    set tile_list [IfuMap:GetSelection]
    foreach tile $tile_list {
	IfuMap:SetTileType $tile $type
    }
    IfuMap:DisplayTypes
    IfuMap:SetSelection ""
    IfuMap:EnableSaveButton
    IfuMap:UpdatePlotStates
}

proc IfuMap:SetTileType {tile type} {
    global IfuMapTileTypes
    set IfuMapTileTypes($tile) $type
}

proc IfuMap:GetTileType {tile} {
    global IfuMapTileTypes
    return $IfuMapTileTypes($tile)
}

proc IfuMap:SetTileValue {tile type} {
    global IfuMapTileValues
    set IfuMapTileValues($tile) $type
}

proc IfuMap:GetTileValue {tile} {
    global IfuMapTileValues
    return $IfuMapTileValues($tile)
}

proc IfuMap:SetTileName {tile name} {
    global IfuMapTileNames
    set IfuMapTileNames($tile) $name
}

proc IfuMap:GetTileName {tile} {
    global IfuMapTileNames
    return $IfuMapTileNames($tile)
}

proc IfuMap:GetTileList {} {
    global IfuMapTileTypes
    return [array names IfuMapTileTypes]
}

proc IfuMap:DisplayTypes {} {

    global IfuMap
    global IfuMapTileA
    
    set canvas $IfuMap(canvas)
    foreach tile [IfuMap:GetTileList] {
	set type [IfuMap:GetTileType $tile]
	$canvas itemconfig "${tile}:type" -text $type
    }
    $canvas raise text
    $canvas raise grid	
}

proc IfuMap:ConfigTiles {colourAname valuesAname typesAname namesAname} {

    global IfuMap

    upvar $colourAname colourA
    upvar $typesAname  typesA
    upvar $valuesAname valuesA
    upvar $namesAname  namesA
	
    set c $IfuMap(canvas)
    set nrows $IfuMap(nrows)
    set ncols $IfuMap(ncols)
    
    for {set i 1} {$i<=$nrows} {incr i 1} {
	for {set j 1} {$j<=$ncols} {incr j 1} {	
	    set tile  ${i}:${j}
	    set type  $typesA($i,$j)
	    set value $valuesA($i,$j)
	    set name  $namesA($i,$j)
	    IfuMap:SetTileType $tile $type
	    IfuMap:SetTileValue $tile $value
	    IfuMap:SetTileName $tile $name
	}
    }

    IfuMap:ColourTiles colourA
    IfuMap:DisplayTypes
    IfuMap:UpdatePlotStates	
}

proc IfuMap:ColourTiles {colourAname} {

    global IfuMap
    upvar $colourAname colourA
	
    set c $IfuMap(canvas)
    set nrows $IfuMap(nrows)
    set ncols $IfuMap(ncols)
    
    for {set i 1} {$i<=$nrows} {incr i 1} {
	for {set j 1} {$j<=$ncols} {incr j 1} {	
	    set tile  ${i}:${j}
	    set scale $colourA($i,$j)
	    set colour grey$scale
	    $c itemconfig $tile -fill $colour -outline ""
	}
    }
}

proc IfuMap:SaveFibInfo {} {

    set filename [IfuMap:GetFibFile]
	
    global IfuMap

    # Set default values to be empty strings
    for {set i 1} {$i<=$IfuMap(nrows)} {incr i 1} {
	for {set j 1} {$j<=$IfuMap(ncols)} {incr j 1} {
	    set tile ${i}:${j}
	    set typesA($i,$j) [IfuMap:GetTileType $tile]
	    set namesA($i,$j) [IfuMap:GetTileName $tile]
	}
    }	
	
    IfuMap:WriteFibInfoFile $filename typesA namesA
    IfuMap:DisableSaveButton
}

proc IfuMap:GetIfuData {ifu_fitsfile dataAname sdataAname} {

    upvar $dataAname dataA
    upvar $sdataAname sdataA

    # Open the ifu fits file get the nrwos and ncols and the data as a list
    set fname $ifu_fitsfile
    set fob [fits open $fname 0]
    set imgdim [$fob info imgdim]
    set ncols [lindex $imgdim 0]
    set nrows [lindex $imgdim 1]	
    set lst [$fob get image]
    $fob close
	
    set dataA(list) $lst
    set dataA(sorted_list) [lsort -real $lst]
	
    # Define a min and max to use for scaling from the list of data
    set minmax [IfuMap:AutoSelectMinMax $lst]
    set min [lindex $minmax 0]
    set max [lindex $minmax 1]
    
    # Define the data Array from the fits image data
    set dataA(ncols) $ncols
    set dataA(nrows) $nrows
    set i 1; set j 1
    foreach itm $lst {
	set dataA($i,$j) $itm
	incr j 1
	if {$j>$ncols} {
	    incr i 1
	    set j 1
	}
    }
	
    # Now create a scaled version of the data using the min and max values
    IfuMap:GenScaleData dataA sdataA $min $max
    
    return [list $min $max]
}

proc IfuMap:AutoSelectMinMax_old {lst} {
	
    set lst2 [lsort -real $lst]
    set min [lindex $lst2 0]
    set max [lindex $lst2 end]

    # Clip all the non positives
    set pidx [vexpr SUM(lst2<=0.0)]
    set lst3 [lrange $lst2 $pidx end]
    set n [llength $lst3]
    if {$n<10} {
	set use_min [lindex $lst3 0]
	set use_max [lindex $lst3 end]
	return [list $use_min $use_max]
    }
	
    # Now look for extreme positive points that could be clipped
    set min [lindex $lst3 0]
    set max [lindex $lst3 end]
    set last_idx [expr $n-2]
    set idx_90 [expr int (0.9*$n)]
    set last_range [expr $max-$min]
    set extreme_found 0
    for {set idx $last_idx} {$idx>=$idx_90} {incr idx -1} {
	set val [lindex $lst3 $idx]
	set range [expr $val-$min]
	set ratio [expr $range/$last_range]
	if {$ratio<0.1} {
	    set extreme_found 1
	    set extreme_idx [expr $idx+1]
	    break
	}
    } 
    if {!$extreme_found} {
	return [list $min $max]
    }
    
    set use_max [lindex $lst3 $idx]
    set use_min $min
    return [list $use_min $use_max]
}

proc IfuMap:AutoSelectMinMax {lst} {
	
    set lst2 [lsort -real $lst]
    set min [lindex $lst2 0]
    set max [lindex $lst2 end]
    
    # Clip all the non positives
    set pidx [vexpr SUM(lst2<=0.0)]
    set lst3 [lrange $lst2 $pidx end]
    set n [llength $lst3]
    if {$n<10} {
	set use_min [lindex $lst3 0]
	set use_max [lindex $lst3 end]
	return [list $use_min $use_max]
    }
	
    # Now look for extreme positive points that could be clipped
    set min [lindex $lst3 0]
    set max [lindex $lst3 end]
    set last_idx [expr $n-2]
    set idx_90 [expr int (0.9*$n)]
    set val [lindex $lst3 [expr $idx_90-1]]
    set low_range [expr $val-$min]
    #MNB#puts "$val $min : $low_range"
    set extreme_found 0
    for {set idx $idx_90} {$idx<=$last_idx} {incr idx} {
	set val [lindex $lst3 $idx]
	set range [expr $val-$min]
	set ratio [expr $low_range/$range]
	set pc [expr int(100.0*$idx/$n)]
	#MNB#puts "$idx ($pc%)-> $val $min : $range $ratio"
	if {$ratio<0.1} {
	    set extreme_found 1
	    set extreme_idx [expr $idx -1]
	    #MNB#puts "Extreme found [lindex $lst3 $extreme_idx]"
	    #MNB#puts "Extreme found [lindex $lst3 [expr $extreme_idx +1]]"
	    #MNB#puts "Extreme found [lindex $lst3 [expr $extreme_idx+2]]"
	    break
	}
    } 

    if {!$extreme_found} {
	return [list $min $max]
    }
			
    set use_max [lindex $lst3 $extreme_idx]
    set use_min $min
    return [list $use_min $use_max]
}

proc IfuMap:AutoSelectFindExtreme {lst3} {

    # Check the supplied (assumed sorted) data list to see
    # if the max point is extreme. We use 
    set min [lindex $lst3 0]
    set max [lindex $lst3 end]
    set last_idx [expr $n-1]
    set idx_90 [expr int (0.9*$n)]
    
    for {set idx1 $idx_90} {$idx1<$last_idx} {incr idx1 1} {
	set val [lindex $lst3 $idx1]
	set low_range [expr $val-$min]
	for {set idx1 [expr $idx1+1]} {$idx2<=$last_idx} {incr idx2 1} {
	    set val [lindex $lst3 $idx2]
	    set high_range [expr $val-$min]
	    set ratio [expr 1.0*$low_range/$high_range]
	    if {$ratio<0.1} {
		set extreme_flag 1
	    }
	}
    }
	
    set last_range [expr $max-$min]
    set extreme_found 0
    for {set idx $last_idx} {$idx>=$idx_90} {incr idx -1} {
	set val [lindex $lst3 $idx]
	set range [expr $val-$min]
	set ratio [expr $range/$last_range]
	if {$ratio<0.1} {
	    set extreme_found 1
	    set extreme_idx [expr $idx+1]
	    break
	}
    } 
	
    return $extreme_found
}

proc IfuMap:GenScaleData {dataAname sdataAname min max} {

    upvar $dataAname dataA
    upvar $sdataAname sdataA
	
    set range [expr $max-$min]
    set ncols $dataA(ncols)
    set nrows $dataA(nrows)
    set sdataA(nrows) $nrows
    set sdataA(ncols) $ncols
    for {set i 1} {$i<=$nrows} {incr i 1} {
	for {set j 1} {$j<=$ncols} {incr j 1} {
	    set val $dataA($i,$j)
	    set scale [expr int(100.0*($val-$min)/$range)]
	    if {$scale>100} {
		set scale 100
	    }
	    if {$scale<0} {
		set scale 0
	    }
	    set sdataA($i,$j) $scale
	}
    }
	
    set sdataA(used_min) $min
    set sdataA(used_max) $max
}

proc IfuMap:GetDefaultTypes {typeAname} {

    upvar $typeAname typeA

    global IfuMap
	
    set row_list [list 1 2 [expr $IfuMap(nrows)-1] $IfuMap(nrows)]
    for {set i 1} {$i<=$IfuMap(nrows)} {incr i 1} {
	for {set j 1} {$j<=$IfuMap(ncols)} {incr j 1} {
	    if {[lsearch $row_list $i]!=-1} {
		set typeA($i,$j) "S"
	    } else {
		set typeA($i,$j) ""
	    }
	}
    }
}

proc IfuMap:ReadFibInfoFile {file typesAname namesAname} {

    upvar $typesAname typesA
    upvar $namesAname namesA

    global IfuMap
	
    # Set default values to be empty strings
    for {set i 1} {$i<=$IfuMap(nrows)} {incr i 1} {
	for {set j 1} {$j<=$IfuMap(ncols)} {incr j 1} {
	    set typesA($i,$j) ""
	    set namesA($i,$j) ""
	}
    }	
    
    if {![file exists $file]} {
	puts "No fibre info file! Using default values"
	IfuMap:GetDefaultTypes typesA
	return 
    }
    
    # Open file
    set fid [open $file r]
    set data [read $fid]
    close $fid
    set lines [split $data \n]
    set pname_list ""
    set elem_list ""
    foreach line $lines {
	set line [string trim $line " "]
	if {$line==""} {
	    continue
	}
	if {[string range $line 0 0]=="#"} {
	    continue
	}
	set x_idx [lindex $line 0]
	set y_idx [lindex $line 1]
	set type  [lindex $line 2]
	set name  [lindex $line 3]
	if {$type=="P"} {
	    if {[lsearch $pname_list $name]==-1} {
		lappend pname_list $name
	    }
	    lappend elem_list "$y_idx,$x_idx"
	}
	set typesA($y_idx,$x_idx) $type
	set namesA($y_idx,$x_idx) $name
    }
	
    set pname_list [lsort $pname_list]
    foreach elem $elem_list {
	set name $namesA($elem)
	set idx [lsearch $pname_list $name]
	incr idx 1
	set typesA($elem) P${idx}
    }
	
    return $pname_list
}

proc IfuMap:WriteFibInfoFile {filename typesAname namesAname} {

    upvar $typesAname typesA
    upvar $namesAname namesA
    global IfuMap
    
    set lines ""
    set line "# X	Y	Type (P/S)	Name"
    lappend lines $line
    
    # Set default values to be empty strings
    for {set i 1} {$i<=$IfuMap(nrows)} {incr i 1} {
	for {set j 1} {$j<=$IfuMap(ncols)} {incr j 1} {
	    if  {$typesA($i,$j)!=""} {
		set type [string range $typesA($i,$j) 0 0]
		set type_id [string range $typesA($i,$j) 1 1]
		if {$type=="P"} {
		    set name [IfuMap:GetPname $type_id]
		} else {
		    set name ""
		}
		#set name $namesA($i,$j)
		#if {$name=="" && $type=="P"} {
		#	set name $type_id
		#}					
		set line "$j\t$i\t$type\t\t\"$name\""
		lappend lines $line
	    }
	}
    }
    set data [join $lines \n]	
	
    # Open file and dump data
    set fid [open $filename w]
    puts $fid $data
    close $fid
}

proc IfuMap:SetReduceFile {filename} {

    global IfuMap
    global IfuMap_tableA

    set IfuMap(reduced_file) $filename
    set columns [FitsOps:TableDump $filename *FIBRES_IFU tableA]
    set colx [lsearch $columns XGPOS]; incr colx 1
    set coly [lsearch $columns YGPOS]; incr coly 1
    for {set row 1} {$row<=$tableA(n_rows)} {incr row 1} {
	set xid $tableA($row,$colx)
	set yid $tableA($row,$coly)
	set IfuMap_tableA($yid,$xid) $row
    }
}

proc IfuMap:GenIfu {red_fitsfile ifu_fitsfile} {
	
    # Get the data from the input reduced file
	
    set columns [FitsOps:TableDump $red_fitsfile *FIBRES_IFU tableA]
    set colx [lsearch $columns XGPOS]; incr colx 1
    set coly [lsearch $columns YGPOS]; incr coly 1
    
    set fob [fits open $red_fitsfile 0]
    
    for {set row 1} {$row<=$tableA(n_rows)} {incr row 1} {
		
	# Map the fibre row no to xid , yid
	set xid $tableA($row,$colx)
	set yid $tableA($row,$coly)
	set IfuMap(row,$yid,$xid) $row
	
	# Now sum the flux for this fibre
	set row_ptr [$fob load irows $row $row]
	# Convert pointer to tcl list
	set row_lst [eval "ptr2lst $row_ptr"]
	# Use vexpr to sum th eelements of this list
	set sum [vexpr "sum(row_lst)/nelem(row_lst)"]
	set IfuMap(data,$yid,$xid) $sum
    }
	
    $fob close
	
    # Output the data into IFU file
    set ifu_lst ""
    for {set yid 1} {$yid<=32} {incr yid 1} {
	for {set xid 1} {$xid<=16} {incr xid 1} {
	    lappend ifu_lst $IfuMap(data,$yid,$xid)
	}
    }

    if {[file exists $ifu_fitsfile]} {
# THIS DOESN'T LOOK RIGHT, Mike, SO I CHANGED IT rwh 1May07
#	file delete file
	file delete $ifu_fitsfile
    }

    set fob [fits open $ifu_fitsfile 2]
    $fob insert image -p -32 2 "16 32"
    $fob put image 1 $ifu_lst
    $fob close
}

proc IfuMap:GetReduceFile {} {
    global IfuMap
    return $IfuMap(reduced_file)
}

proc IfuMap:Tile2FibreNo {tile} {
    global IfuMap_tableA
    set rowcol [split $tile :]
    set row [lindex $rowcol 0]
    set col [lindex $rowcol 1]
    set fibreno $IfuMap_tableA($row,$col)
    return $fibreno
}

proc IfuMap:SumRows {fitsfile rowlist {outfile ""}} {

    set waveflag 1

    set fob [fits open $fitsfile 0]
	
    set n [llength $rowlist]
    set first 1
    foreach row $rowlist {
	set row_ptr [$fob load irows $row $row]
	# Convert pointer to tcl list
	set row_lst [eval "ptr2lst $row_ptr"]
	if {$first} {
	    set first 0
	    set sum_lst $row_lst
	} else {
	    set sum_lst [vexpr sum_lst+row_lst]
	}
    }
    if {$n>1} {
	set sum_lst [vexpr sum_lst/$n]
    }
    $fob close
    if {$outfile==""} {
	return $sum_lst
    }
    
    # Output tcl list to text file
    if {[file exists $outfile]} {
	file delete $outfile
    }
    set fid [open $outfile w]
    
    if {$waveflag} {
	set crval1 [FitsOps:GetKeyWord $fitsfile CRVAL1]
	set cdelt1 [FitsOps:GetKeyWord $fitsfile CDELT1]
	set crpix1 [FitsOps:GetKeyWord $fitsfile CRPIX1]
	set ctype1 [FitsOps:GetKeyWord $fitsfile CTYPE1]
	set cunit1 [FitsOps:GetKeyWord $fitsfile CUNIT1]
	set idx 0
	foreach itm $sum_lst {
	    incr idx 1
	    set xval [expr $crval1+($idx-$crpix1)*$cdelt1]
	    puts $fid "$xval $itm"
	}
	close $fid
	return
    }
	
    set idx 1
    foreach itm $sum_lst {
	puts $fid "$idx $itm"
	incr idx 1
    }
    close $fid
}

proc IfuMap:ViewSumRows {fitsfile rowlist} {
    set tmpfile tmp_sumrows.dat
    IfuMap:SumRows $fitsfile $rowlist $tmpfile
    tclGraph:OpenGraph $tmpfile
}

proc IfuMap:SetPnames {pnames} {

    global IfuMap

    set idx 0
    foreach pname $pnames {
	incr idx 1
	set IfuMap(pnames,$idx) $pname
    }
}

proc IfuMap:GetPname {idx} {
    global IfuMap
    return $IfuMap(pnames,$idx)
}

proc IfuMap:GetFilesPanel {{redfile ""} {fibfile ""}} {

    global IfuMapGetFilesPanel
	
    set root .ifuMapGetFilesPanel
    destroy $root
    toplevel $root
    wm title $root "IFU Map Files:"
	
    frame $root.top -relief raised -bd 2
    frame $root.bot -relief raised -bd 2
    pack $root.top $root.bot -fill x
    
    set lroot $root.top
    label $lroot.l1 -text "AAOmegaIFU Reduced file:"
    entry $lroot.e1 -width 32 -textvariable IfuMapGetFilesPanel(disvar,redfile)
    button $lroot.b1 -text "Browse..." -command {
	set file_types {{"Reduced file" {"*red.fits"}}}
	set redfile [tk_getOpenFile -filetypes $file_types]
	set redfile [file tail $redfile]
	set IfuMapGetFilesPanel(disvar,redfile) $redfile
    }
    label $lroot.l2 -text "Fibre Info File:"
    entry $lroot.e2 -width 32 -textvariable IfuMapGetFilesPanel(disvar,fibfile)
    button $lroot.b2 -text "Browse..." -command {
	set file_types {{"IFU Fibre data file" {"*.dat"}}}
	set redfile [tk_getSaveFile -filetypes $file_types]
	set redfile [file tail $redfile]
	set IfuMapGetFilesPanel(disvar,fibfile) $redfile
    }
    grid $lroot.l1 -row 1 -column 1 -sticky e
    grid $lroot.e1 -row 1 -column 2 
    grid $lroot.b1 -row 1 -column 3 -sticky w
    grid $lroot.l2 -row 2 -column 1 -sticky e
    grid $lroot.e2 -row 2 -column 2 
    grid $lroot.b2 -row 2 -column 3 -sticky w
    
    button $root.bot.ok -text OK -width 7\
	-command "set IfuMapGetFilesPanel(flag,ok) 1; destroy $root"
    button $root.bot.ca -text Cancel -width 7 -command "destroy $root"
    pack  $root.bot.ok $root.bot.ca -side left -padx 4m -pady 4m -expand 1
    
    set IfuMapGetFilesPanel(flag,ok) 0
    set IfuMapGetFilesPanel(disvar,redfile) $redfile
    set IfuMapGetFilesPanel(disvar,fibfile) $fibfile
    tkwait window $root
    if {!$IfuMapGetFilesPanel(flag,ok)} {
	return ""
    }
    set redfile $IfuMapGetFilesPanel(disvar,redfile)
    set fibfile $IfuMapGetFilesPanel(disvar,fibfile)
    if {$redfile==""} {
	tk_messageBox -message "Must select a reduced file!"
	return ""
    }
    if {$fibfile==""} {
	tk_messageBox -message "Must specify a fibre info file!"
	return ""
    }
    if {![file exists $redfile]} {
	tk_messageBox -message "Cannot find reduced file $redfile"
	return ""
    }
    if {![file exists $fibfile]} {
	set reply [tk_messageBox -type yesno\
		       -message "$fibfile does not exist. Create new one?"]
	if {$reply=="no"} {
	    return ""
	}
    }
	
    return [list $redfile $fibfile]
    IfuMap $redfile $fibfile
}

proc IfuMap:SetFibFile {fibfile} {
    global IfuMap
    set IfuMap(filename,fibfile) $fibfile
}

proc IfuMap:GetFibFile {} {
    global IfuMap
    return $IfuMap(filename,fibfile)
}

proc IfuMap:Main {red_fitsfile tst_fibinfofile \
		      {tmpifu_fitsfile tmp_ifu.fits}} {

    global IfuMap:dataA
    global IfuMap:sdataA

    IfuMap:CreateWindow
    IfuMap:SetReduceFile $red_fitsfile
    IfuMap:GenIfu $red_fitsfile $tmpifu_fitsfile
    IfuMap:GetIfuData $tmpifu_fitsfile IfuMap:dataA IfuMap:sdataA
    set pnames [IfuMap:ReadFibInfoFile $tst_fibinfofile typesA namesA]
    IfuMap:SetPnames $pnames
    IfuMap:SetFibFile $tst_fibinfofile
    IfuMap:ConfigTiles IfuMap:sdataA IfuMap:dataA typesA namesA
}


# X and Y Cut plots
    proc IfuMap:PlotXYCut {} {
    set selected_tiles [IfuMap:GetSelection]
    set tile [lindex $selected_tiles]
    set rowcol [split  $tile :]
    set i [lindex $rowcol 0]
    set j [lindex $rowcol 1]
    IfuMap:XYCuts $i $j
  
    }

    proc IfuMap:XYCuts {i0 j0} {
    
    set xfile tmp_xcut.dat
    set yfile tmp_ycut.dat
    set xcut_data ""
    set ycut_data ""

    global IfuMap
    set nrows $IfuMap(nrows)
    set ncols $IfuMap(ncols)
    
    for {set i 1} {$i<=$nrows} {incr i 1} {
       set tile      ${i}:${j0} 
       set value [IfuMap:GetTileValue $tile]
       lappend ycut_data [list [expr $i-0.5] $value]
       lappend ycut_data [list [expr $i+0.5] $value]
    }
    
    for {set j 1} {$j<=$ncols} {incr j 1} {
       set tile      ${i0}:${j} 
       set value [IfuMap:GetTileValue $tile]
       lappend xcut_data [list [expr $j-0.5] $value]
       lappend xcut_data [list [expr $j+0.5] $value]
    }
    
    set fid [open $xfile w]
    puts $fid [join $xcut_data \n]
    close $fid
    tclGraph:OpenGraph $xfile

    set fid [open $yfile w]
    puts $fid [join $ycut_data \n]
    close $fid
    tclGraph:OpenGraph $yfile
    
   }

proc IfuMap {{redfile ""} {fibfile ""}} {
    if {$redfile=="" || $fibfile==""} {
	set flist [IfuMap:GetFilesPanel $redfile $fibfile]
	if {$flist==""} {
	    return
	}
	set redfile [lindex $flist 0]
	set fibfile [lindex $flist 1]
    }
    if {$redfile=="" || $fibfile==""} {
	return
    }
    
    IfuMap:Main $redfile $fibfile
}

# Test code
proc IfuMap:Test {} {
global tcl_interactive
global IfuMap
set red_fitsfile    23jun10040red.fits; # The reduced file we are looking at
set tmpifu_fitsfile tmp_ifutest.fits  ; # A temp ifu file we generate
set tst_fibinfofile fibinfo_test.dat  ; # The fibinfo file that we edit
IfuMap:Main $red_fitsfile $tst_fibinfofile $tmpifu_fitsfile
# If this is not an interactive session then wait until the IfuMap root window
# is destroyed.
if {$tcl_interactive==0} {
    tkwait window $IfuMap(root)
}
}
